# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DataprocClusterArgs', 'DataprocCluster']

@pulumi.input_type
class DataprocClusterArgs:
    def __init__(__self__, *,
                 cluster_config: pulumi.Input['DataprocClusterClusterConfigArgs'],
                 service_account_id: pulumi.Input[str],
                 bucket: Optional[pulumi.Input[str]] = None,
                 deletion_protection: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 host_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ui_proxy: Optional[pulumi.Input[bool]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a DataprocCluster resource.
        :param pulumi.Input['DataprocClusterClusterConfigArgs'] cluster_config: Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        :param pulumi.Input[str] service_account_id: Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        :param pulumi.Input[str] bucket: Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        :param pulumi.Input[bool] deletion_protection: Inhibits deletion of the cluster.  Can be either `true` or `false`.
        :param pulumi.Input[str] description: Description of the Data Proc cluster.
        :param pulumi.Input[str] folder_id: ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_group_ids: A list of host group IDs to place VMs of the cluster on.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Data Proc cluster.
        :param pulumi.Input[str] name: Name of the Data Proc subcluster.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A list of security group IDs that the cluster belongs to.
        :param pulumi.Input[bool] ui_proxy: Whether to enable UI Proxy feature.
        :param pulumi.Input[str] zone_id: ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        pulumi.set(__self__, "cluster_config", cluster_config)
        pulumi.set(__self__, "service_account_id", service_account_id)
        if bucket is not None:
            pulumi.set(__self__, "bucket", bucket)
        if deletion_protection is not None:
            pulumi.set(__self__, "deletion_protection", deletion_protection)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if host_group_ids is not None:
            pulumi.set(__self__, "host_group_ids", host_group_ids)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if ui_proxy is not None:
            pulumi.set(__self__, "ui_proxy", ui_proxy)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="clusterConfig")
    def cluster_config(self) -> pulumi.Input['DataprocClusterClusterConfigArgs']:
        """
        Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        """
        return pulumi.get(self, "cluster_config")

    @cluster_config.setter
    def cluster_config(self, value: pulumi.Input['DataprocClusterClusterConfigArgs']):
        pulumi.set(self, "cluster_config", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> pulumi.Input[str]:
        """
        Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter(name="deletionProtection")
    def deletion_protection(self) -> Optional[pulumi.Input[bool]]:
        """
        Inhibits deletion of the cluster.  Can be either `true` or `false`.
        """
        return pulumi.get(self, "deletion_protection")

    @deletion_protection.setter
    def deletion_protection(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "deletion_protection", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the Data Proc cluster.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter(name="hostGroupIds")
    def host_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of host group IDs to place VMs of the cluster on.
        """
        return pulumi.get(self, "host_group_ids")

    @host_group_ids.setter
    def host_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_group_ids", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the Data Proc cluster.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Data Proc subcluster.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of security group IDs that the cluster belongs to.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="uiProxy")
    def ui_proxy(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable UI Proxy feature.
        """
        return pulumi.get(self, "ui_proxy")

    @ui_proxy.setter
    def ui_proxy(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ui_proxy", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


@pulumi.input_type
class _DataprocClusterState:
    def __init__(__self__, *,
                 bucket: Optional[pulumi.Input[str]] = None,
                 cluster_config: Optional[pulumi.Input['DataprocClusterClusterConfigArgs']] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 deletion_protection: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 host_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 ui_proxy: Optional[pulumi.Input[bool]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DataprocCluster resources.
        :param pulumi.Input[str] bucket: Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        :param pulumi.Input['DataprocClusterClusterConfigArgs'] cluster_config: Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        :param pulumi.Input[str] created_at: (Computed) The Data Proc cluster creation timestamp.
               * `cluster_config.0.subcluster_spec.X.id` - (Computed) ID of the subcluster.
        :param pulumi.Input[bool] deletion_protection: Inhibits deletion of the cluster.  Can be either `true` or `false`.
        :param pulumi.Input[str] description: Description of the Data Proc cluster.
        :param pulumi.Input[str] folder_id: ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_group_ids: A list of host group IDs to place VMs of the cluster on.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Data Proc cluster.
        :param pulumi.Input[str] name: Name of the Data Proc subcluster.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A list of security group IDs that the cluster belongs to.
        :param pulumi.Input[str] service_account_id: Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        :param pulumi.Input[bool] ui_proxy: Whether to enable UI Proxy feature.
        :param pulumi.Input[str] zone_id: ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        if bucket is not None:
            pulumi.set(__self__, "bucket", bucket)
        if cluster_config is not None:
            pulumi.set(__self__, "cluster_config", cluster_config)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if deletion_protection is not None:
            pulumi.set(__self__, "deletion_protection", deletion_protection)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if host_group_ids is not None:
            pulumi.set(__self__, "host_group_ids", host_group_ids)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if service_account_id is not None:
            pulumi.set(__self__, "service_account_id", service_account_id)
        if ui_proxy is not None:
            pulumi.set(__self__, "ui_proxy", ui_proxy)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter(name="clusterConfig")
    def cluster_config(self) -> Optional[pulumi.Input['DataprocClusterClusterConfigArgs']]:
        """
        Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        """
        return pulumi.get(self, "cluster_config")

    @cluster_config.setter
    def cluster_config(self, value: Optional[pulumi.Input['DataprocClusterClusterConfigArgs']]):
        pulumi.set(self, "cluster_config", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed) The Data Proc cluster creation timestamp.
        * `cluster_config.0.subcluster_spec.X.id` - (Computed) ID of the subcluster.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="deletionProtection")
    def deletion_protection(self) -> Optional[pulumi.Input[bool]]:
        """
        Inhibits deletion of the cluster.  Can be either `true` or `false`.
        """
        return pulumi.get(self, "deletion_protection")

    @deletion_protection.setter
    def deletion_protection(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "deletion_protection", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the Data Proc cluster.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter(name="hostGroupIds")
    def host_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of host group IDs to place VMs of the cluster on.
        """
        return pulumi.get(self, "host_group_ids")

    @host_group_ids.setter
    def host_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_group_ids", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the Data Proc cluster.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the Data Proc subcluster.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of security group IDs that the cluster belongs to.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter(name="uiProxy")
    def ui_proxy(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable UI Proxy feature.
        """
        return pulumi.get(self, "ui_proxy")

    @ui_proxy.setter
    def ui_proxy(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "ui_proxy", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class DataprocCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input[str]] = None,
                 cluster_config: Optional[pulumi.Input[pulumi.InputType['DataprocClusterClusterConfigArgs']]] = None,
                 deletion_protection: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 host_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 ui_proxy: Optional[pulumi.Input[bool]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages a Data Proc cluster. For more information, see [the official documentation](https://cloud.yandex.com/docs/data-proc/).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            zone="ru-central1-b",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.1.0.0/24"])
        dataproc_iam_service_account = yandex.IamServiceAccount("dataprocIamServiceAccount", description="service account to manage Dataproc Cluster")
        foo_resourcemanager_folder = yandex.get_resourcemanager_folder(folder_id="some_folder_id")
        dataproc_resourcemanager_folder_iam_binding = yandex.ResourcemanagerFolderIamBinding("dataprocResourcemanagerFolderIamBinding",
            folder_id=foo_resourcemanager_folder.id,
            role="mdb.dataproc.agent",
            members=[dataproc_iam_service_account.id.apply(lambda id: f"serviceAccount:{id}")])
        # required in order to create bucket
        bucket_creator = yandex.ResourcemanagerFolderIamBinding("bucket-creator",
            folder_id=foo_resourcemanager_folder.id,
            role="editor",
            members=[dataproc_iam_service_account.id.apply(lambda id: f"serviceAccount:{id}")])
        foo_iam_service_account_static_access_key = yandex.IamServiceAccountStaticAccessKey("fooIamServiceAccountStaticAccessKey", service_account_id=dataproc_iam_service_account.id)
        foo_storage_bucket = yandex.StorageBucket("fooStorageBucket",
            bucket="foo",
            access_key=foo_iam_service_account_static_access_key.access_key,
            secret_key=foo_iam_service_account_static_access_key.secret_key,
            opts=pulumi.ResourceOptions(depends_on=[bucket_creator]))
        foo_dataproc_cluster = yandex.DataprocCluster("fooDataprocCluster",
            bucket=foo_storage_bucket.bucket,
            description="Dataproc Cluster created by Terraform",
            labels={
                "created_by": "terraform",
            },
            service_account_id=dataproc_iam_service_account.id,
            zone_id="ru-central1-b",
            cluster_config=yandex.DataprocClusterClusterConfigArgs(
                hadoop=yandex.DataprocClusterClusterConfigHadoopArgs(
                    services=[
                        "HDFS",
                        "YARN",
                        "SPARK",
                        "TEZ",
                        "MAPREDUCE",
                        "HIVE",
                    ],
                    properties={
                        "yarn:yarn.resourcemanager.am.max-attempts": "5",
                    },
                    ssh_public_keys=[(lambda path: open(path).read())("~/.ssh/id_rsa.pub")],
                ),
                subcluster_specs=[
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="main",
                        role="MASTERNODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=1,
                    ),
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="data",
                        role="DATANODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=2,
                    ),
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="compute",
                        role="COMPUTENODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=2,
                    ),
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="compute_autoscaling",
                        role="COMPUTENODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=2,
                        autoscaling_config=yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigArgs(
                            max_hosts_count=10,
                            measurement_duration=60,
                            warmup_duration=60,
                            stabilization_duration=120,
                            preemptible=False,
                            decommission_timeout=60,
                        ),
                    ),
                ],
            ),
            opts=pulumi.ResourceOptions(depends_on=[dataproc_resourcemanager_folder_iam_binding]))
        ```

        ## Import

        A cluster can be imported using the `id` of the resource, e.g.

        ```sh
         $ pulumi import yandex:index/dataprocCluster:DataprocCluster foo cluster_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bucket: Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        :param pulumi.Input[pulumi.InputType['DataprocClusterClusterConfigArgs']] cluster_config: Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        :param pulumi.Input[bool] deletion_protection: Inhibits deletion of the cluster.  Can be either `true` or `false`.
        :param pulumi.Input[str] description: Description of the Data Proc cluster.
        :param pulumi.Input[str] folder_id: ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_group_ids: A list of host group IDs to place VMs of the cluster on.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Data Proc cluster.
        :param pulumi.Input[str] name: Name of the Data Proc subcluster.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A list of security group IDs that the cluster belongs to.
        :param pulumi.Input[str] service_account_id: Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        :param pulumi.Input[bool] ui_proxy: Whether to enable UI Proxy feature.
        :param pulumi.Input[str] zone_id: ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DataprocClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a Data Proc cluster. For more information, see [the official documentation](https://cloud.yandex.com/docs/data-proc/).

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            zone="ru-central1-b",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.1.0.0/24"])
        dataproc_iam_service_account = yandex.IamServiceAccount("dataprocIamServiceAccount", description="service account to manage Dataproc Cluster")
        foo_resourcemanager_folder = yandex.get_resourcemanager_folder(folder_id="some_folder_id")
        dataproc_resourcemanager_folder_iam_binding = yandex.ResourcemanagerFolderIamBinding("dataprocResourcemanagerFolderIamBinding",
            folder_id=foo_resourcemanager_folder.id,
            role="mdb.dataproc.agent",
            members=[dataproc_iam_service_account.id.apply(lambda id: f"serviceAccount:{id}")])
        # required in order to create bucket
        bucket_creator = yandex.ResourcemanagerFolderIamBinding("bucket-creator",
            folder_id=foo_resourcemanager_folder.id,
            role="editor",
            members=[dataproc_iam_service_account.id.apply(lambda id: f"serviceAccount:{id}")])
        foo_iam_service_account_static_access_key = yandex.IamServiceAccountStaticAccessKey("fooIamServiceAccountStaticAccessKey", service_account_id=dataproc_iam_service_account.id)
        foo_storage_bucket = yandex.StorageBucket("fooStorageBucket",
            bucket="foo",
            access_key=foo_iam_service_account_static_access_key.access_key,
            secret_key=foo_iam_service_account_static_access_key.secret_key,
            opts=pulumi.ResourceOptions(depends_on=[bucket_creator]))
        foo_dataproc_cluster = yandex.DataprocCluster("fooDataprocCluster",
            bucket=foo_storage_bucket.bucket,
            description="Dataproc Cluster created by Terraform",
            labels={
                "created_by": "terraform",
            },
            service_account_id=dataproc_iam_service_account.id,
            zone_id="ru-central1-b",
            cluster_config=yandex.DataprocClusterClusterConfigArgs(
                hadoop=yandex.DataprocClusterClusterConfigHadoopArgs(
                    services=[
                        "HDFS",
                        "YARN",
                        "SPARK",
                        "TEZ",
                        "MAPREDUCE",
                        "HIVE",
                    ],
                    properties={
                        "yarn:yarn.resourcemanager.am.max-attempts": "5",
                    },
                    ssh_public_keys=[(lambda path: open(path).read())("~/.ssh/id_rsa.pub")],
                ),
                subcluster_specs=[
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="main",
                        role="MASTERNODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=1,
                    ),
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="data",
                        role="DATANODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=2,
                    ),
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="compute",
                        role="COMPUTENODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=2,
                    ),
                    yandex.DataprocClusterClusterConfigSubclusterSpecArgs(
                        name="compute_autoscaling",
                        role="COMPUTENODE",
                        resources=yandex.DataprocClusterClusterConfigSubclusterSpecResourcesArgs(
                            resource_preset_id="s2.small",
                            disk_type_id="network-hdd",
                            disk_size=20,
                        ),
                        subnet_id=foo_vpc_subnet.id,
                        hosts_count=2,
                        autoscaling_config=yandex.DataprocClusterClusterConfigSubclusterSpecAutoscalingConfigArgs(
                            max_hosts_count=10,
                            measurement_duration=60,
                            warmup_duration=60,
                            stabilization_duration=120,
                            preemptible=False,
                            decommission_timeout=60,
                        ),
                    ),
                ],
            ),
            opts=pulumi.ResourceOptions(depends_on=[dataproc_resourcemanager_folder_iam_binding]))
        ```

        ## Import

        A cluster can be imported using the `id` of the resource, e.g.

        ```sh
         $ pulumi import yandex:index/dataprocCluster:DataprocCluster foo cluster_id
        ```

        :param str resource_name: The name of the resource.
        :param DataprocClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DataprocClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input[str]] = None,
                 cluster_config: Optional[pulumi.Input[pulumi.InputType['DataprocClusterClusterConfigArgs']]] = None,
                 deletion_protection: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 host_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 ui_proxy: Optional[pulumi.Input[bool]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DataprocClusterArgs.__new__(DataprocClusterArgs)

            __props__.__dict__["bucket"] = bucket
            if cluster_config is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_config'")
            __props__.__dict__["cluster_config"] = cluster_config
            __props__.__dict__["deletion_protection"] = deletion_protection
            __props__.__dict__["description"] = description
            __props__.__dict__["folder_id"] = folder_id
            __props__.__dict__["host_group_ids"] = host_group_ids
            __props__.__dict__["labels"] = labels
            __props__.__dict__["name"] = name
            __props__.__dict__["security_group_ids"] = security_group_ids
            if service_account_id is None and not opts.urn:
                raise TypeError("Missing required property 'service_account_id'")
            __props__.__dict__["service_account_id"] = service_account_id
            __props__.__dict__["ui_proxy"] = ui_proxy
            __props__.__dict__["zone_id"] = zone_id
            __props__.__dict__["created_at"] = None
        super(DataprocCluster, __self__).__init__(
            'yandex:index/dataprocCluster:DataprocCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bucket: Optional[pulumi.Input[str]] = None,
            cluster_config: Optional[pulumi.Input[pulumi.InputType['DataprocClusterClusterConfigArgs']]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            deletion_protection: Optional[pulumi.Input[bool]] = None,
            description: Optional[pulumi.Input[str]] = None,
            folder_id: Optional[pulumi.Input[str]] = None,
            host_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            service_account_id: Optional[pulumi.Input[str]] = None,
            ui_proxy: Optional[pulumi.Input[bool]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'DataprocCluster':
        """
        Get an existing DataprocCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bucket: Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        :param pulumi.Input[pulumi.InputType['DataprocClusterClusterConfigArgs']] cluster_config: Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        :param pulumi.Input[str] created_at: (Computed) The Data Proc cluster creation timestamp.
               * `cluster_config.0.subcluster_spec.X.id` - (Computed) ID of the subcluster.
        :param pulumi.Input[bool] deletion_protection: Inhibits deletion of the cluster.  Can be either `true` or `false`.
        :param pulumi.Input[str] description: Description of the Data Proc cluster.
        :param pulumi.Input[str] folder_id: ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_group_ids: A list of host group IDs to place VMs of the cluster on.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Data Proc cluster.
        :param pulumi.Input[str] name: Name of the Data Proc subcluster.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A list of security group IDs that the cluster belongs to.
        :param pulumi.Input[str] service_account_id: Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        :param pulumi.Input[bool] ui_proxy: Whether to enable UI Proxy feature.
        :param pulumi.Input[str] zone_id: ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DataprocClusterState.__new__(_DataprocClusterState)

        __props__.__dict__["bucket"] = bucket
        __props__.__dict__["cluster_config"] = cluster_config
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["deletion_protection"] = deletion_protection
        __props__.__dict__["description"] = description
        __props__.__dict__["folder_id"] = folder_id
        __props__.__dict__["host_group_ids"] = host_group_ids
        __props__.__dict__["labels"] = labels
        __props__.__dict__["name"] = name
        __props__.__dict__["security_group_ids"] = security_group_ids
        __props__.__dict__["service_account_id"] = service_account_id
        __props__.__dict__["ui_proxy"] = ui_proxy
        __props__.__dict__["zone_id"] = zone_id
        return DataprocCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Output[Optional[str]]:
        """
        Name of the Object Storage bucket to use for Data Proc jobs. Data Proc Agent saves output of job driver's process to specified bucket. In order for this to work service account (specified by the `service_account_id` argument) should be given permission to create objects within this bucket.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="clusterConfig")
    def cluster_config(self) -> pulumi.Output['outputs.DataprocClusterClusterConfig']:
        """
        Configuration and resources for hosts that should be created with the cluster. The structure is documented below.
        """
        return pulumi.get(self, "cluster_config")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        (Computed) The Data Proc cluster creation timestamp.
        * `cluster_config.0.subcluster_spec.X.id` - (Computed) ID of the subcluster.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="deletionProtection")
    def deletion_protection(self) -> pulumi.Output[bool]:
        """
        Inhibits deletion of the cluster.  Can be either `true` or `false`.
        """
        return pulumi.get(self, "deletion_protection")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the Data Proc cluster.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> pulumi.Output[str]:
        """
        ID of the folder to create a cluster in. If it is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @property
    @pulumi.getter(name="hostGroupIds")
    def host_group_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        A list of host group IDs to place VMs of the cluster on.
        """
        return pulumi.get(self, "host_group_ids")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        A set of key/value label pairs to assign to the Data Proc cluster.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the Data Proc subcluster.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        A list of security group IDs that the cluster belongs to.
        """
        return pulumi.get(self, "security_group_ids")

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> pulumi.Output[str]:
        """
        Service account to be used by the Data Proc agent to access resources of Yandex.Cloud. Selected service account should have `mdb.dataproc.agent` role on the folder where the Data Proc cluster will be located.
        """
        return pulumi.get(self, "service_account_id")

    @property
    @pulumi.getter(name="uiProxy")
    def ui_proxy(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether to enable UI Proxy feature.
        """
        return pulumi.get(self, "ui_proxy")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        ID of the availability zone to create cluster in. If it is not provided, the default provider zone is used.
        """
        return pulumi.get(self, "zone_id")

