# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['FunctionArgs', 'Function']

@pulumi.input_type
class FunctionArgs:
    def __init__(__self__, *,
                 entrypoint: pulumi.Input[str],
                 memory: pulumi.Input[int],
                 runtime: pulumi.Input[str],
                 user_hash: pulumi.Input[str],
                 content: Optional[pulumi.Input['FunctionContentArgs']] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 execution_timeout: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 package: Optional[pulumi.Input['FunctionPackageArgs']] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a Function resource.
        :param pulumi.Input[str] entrypoint: Entrypoint for Yandex Cloud Function
        :param pulumi.Input[int] memory: Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        :param pulumi.Input[str] runtime: Runtime for Yandex Cloud Function
        :param pulumi.Input[str] user_hash: User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        :param pulumi.Input['FunctionContentArgs'] content: Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `content.0.zip_filename` - Filename to zip archive for the version.
        :param pulumi.Input[str] description: Description of the Yandex Cloud Function
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] environment: A set of key/value environment variables for Yandex Cloud Function
        :param pulumi.Input[str] execution_timeout: Execution timeout in seconds for Yandex Cloud Function
        :param pulumi.Input[str] folder_id: Folder ID for the Yandex Cloud Function
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Yandex Cloud Function
        :param pulumi.Input[str] name: Yandex Cloud Function name used to define trigger
        :param pulumi.Input['FunctionPackageArgs'] package: Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `package.0.sha_256` - SHA256 hash of the version deployment package.
               * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
               * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        :param pulumi.Input[str] service_account_id: Service account ID for Yandex Cloud Function
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        """
        pulumi.set(__self__, "entrypoint", entrypoint)
        pulumi.set(__self__, "memory", memory)
        pulumi.set(__self__, "runtime", runtime)
        pulumi.set(__self__, "user_hash", user_hash)
        if content is not None:
            pulumi.set(__self__, "content", content)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if environment is not None:
            pulumi.set(__self__, "environment", environment)
        if execution_timeout is not None:
            pulumi.set(__self__, "execution_timeout", execution_timeout)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if package is not None:
            pulumi.set(__self__, "package", package)
        if service_account_id is not None:
            pulumi.set(__self__, "service_account_id", service_account_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def entrypoint(self) -> pulumi.Input[str]:
        """
        Entrypoint for Yandex Cloud Function
        """
        return pulumi.get(self, "entrypoint")

    @entrypoint.setter
    def entrypoint(self, value: pulumi.Input[str]):
        pulumi.set(self, "entrypoint", value)

    @property
    @pulumi.getter
    def memory(self) -> pulumi.Input[int]:
        """
        Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        """
        return pulumi.get(self, "memory")

    @memory.setter
    def memory(self, value: pulumi.Input[int]):
        pulumi.set(self, "memory", value)

    @property
    @pulumi.getter
    def runtime(self) -> pulumi.Input[str]:
        """
        Runtime for Yandex Cloud Function
        """
        return pulumi.get(self, "runtime")

    @runtime.setter
    def runtime(self, value: pulumi.Input[str]):
        pulumi.set(self, "runtime", value)

    @property
    @pulumi.getter(name="userHash")
    def user_hash(self) -> pulumi.Input[str]:
        """
        User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        """
        return pulumi.get(self, "user_hash")

    @user_hash.setter
    def user_hash(self, value: pulumi.Input[str]):
        pulumi.set(self, "user_hash", value)

    @property
    @pulumi.getter
    def content(self) -> Optional[pulumi.Input['FunctionContentArgs']]:
        """
        Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
        * `content.0.zip_filename` - Filename to zip archive for the version.
        """
        return pulumi.get(self, "content")

    @content.setter
    def content(self, value: Optional[pulumi.Input['FunctionContentArgs']]):
        pulumi.set(self, "content", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the Yandex Cloud Function
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def environment(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value environment variables for Yandex Cloud Function
        """
        return pulumi.get(self, "environment")

    @environment.setter
    def environment(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "environment", value)

    @property
    @pulumi.getter(name="executionTimeout")
    def execution_timeout(self) -> Optional[pulumi.Input[str]]:
        """
        Execution timeout in seconds for Yandex Cloud Function
        """
        return pulumi.get(self, "execution_timeout")

    @execution_timeout.setter
    def execution_timeout(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "execution_timeout", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        Folder ID for the Yandex Cloud Function
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the Yandex Cloud Function
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Yandex Cloud Function name used to define trigger
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def package(self) -> Optional[pulumi.Input['FunctionPackageArgs']]:
        """
        Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
        * `package.0.sha_256` - SHA256 hash of the version deployment package.
        * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
        * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        """
        return pulumi.get(self, "package")

    @package.setter
    def package(self, value: Optional[pulumi.Input['FunctionPackageArgs']]):
        pulumi.set(self, "package", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        Service account ID for Yandex Cloud Function
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _FunctionState:
    def __init__(__self__, *,
                 content: Optional[pulumi.Input['FunctionContentArgs']] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 entrypoint: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 execution_timeout: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 image_size: Optional[pulumi.Input[int]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 loggroup_id: Optional[pulumi.Input[str]] = None,
                 memory: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 package: Optional[pulumi.Input['FunctionPackageArgs']] = None,
                 runtime: Optional[pulumi.Input[str]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 user_hash: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Function resources.
        :param pulumi.Input['FunctionContentArgs'] content: Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `content.0.zip_filename` - Filename to zip archive for the version.
        :param pulumi.Input[str] created_at: Creation timestamp of the Yandex Cloud Function.
        :param pulumi.Input[str] description: Description of the Yandex Cloud Function
        :param pulumi.Input[str] entrypoint: Entrypoint for Yandex Cloud Function
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] environment: A set of key/value environment variables for Yandex Cloud Function
        :param pulumi.Input[str] execution_timeout: Execution timeout in seconds for Yandex Cloud Function
        :param pulumi.Input[str] folder_id: Folder ID for the Yandex Cloud Function
        :param pulumi.Input[int] image_size: Image size for Yandex Cloud Function.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Yandex Cloud Function
        :param pulumi.Input[str] loggroup_id: Loggroup ID size for Yandex Cloud Function.
        :param pulumi.Input[int] memory: Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        :param pulumi.Input[str] name: Yandex Cloud Function name used to define trigger
        :param pulumi.Input['FunctionPackageArgs'] package: Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `package.0.sha_256` - SHA256 hash of the version deployment package.
               * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
               * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        :param pulumi.Input[str] runtime: Runtime for Yandex Cloud Function
        :param pulumi.Input[str] service_account_id: Service account ID for Yandex Cloud Function
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        :param pulumi.Input[str] user_hash: User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        :param pulumi.Input[str] version: Version for Yandex Cloud Function.
        """
        if content is not None:
            pulumi.set(__self__, "content", content)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if entrypoint is not None:
            pulumi.set(__self__, "entrypoint", entrypoint)
        if environment is not None:
            pulumi.set(__self__, "environment", environment)
        if execution_timeout is not None:
            pulumi.set(__self__, "execution_timeout", execution_timeout)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if image_size is not None:
            pulumi.set(__self__, "image_size", image_size)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if loggroup_id is not None:
            pulumi.set(__self__, "loggroup_id", loggroup_id)
        if memory is not None:
            pulumi.set(__self__, "memory", memory)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if package is not None:
            pulumi.set(__self__, "package", package)
        if runtime is not None:
            pulumi.set(__self__, "runtime", runtime)
        if service_account_id is not None:
            pulumi.set(__self__, "service_account_id", service_account_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if user_hash is not None:
            pulumi.set(__self__, "user_hash", user_hash)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def content(self) -> Optional[pulumi.Input['FunctionContentArgs']]:
        """
        Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
        * `content.0.zip_filename` - Filename to zip archive for the version.
        """
        return pulumi.get(self, "content")

    @content.setter
    def content(self, value: Optional[pulumi.Input['FunctionContentArgs']]):
        pulumi.set(self, "content", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        Creation timestamp of the Yandex Cloud Function.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the Yandex Cloud Function
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def entrypoint(self) -> Optional[pulumi.Input[str]]:
        """
        Entrypoint for Yandex Cloud Function
        """
        return pulumi.get(self, "entrypoint")

    @entrypoint.setter
    def entrypoint(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "entrypoint", value)

    @property
    @pulumi.getter
    def environment(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value environment variables for Yandex Cloud Function
        """
        return pulumi.get(self, "environment")

    @environment.setter
    def environment(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "environment", value)

    @property
    @pulumi.getter(name="executionTimeout")
    def execution_timeout(self) -> Optional[pulumi.Input[str]]:
        """
        Execution timeout in seconds for Yandex Cloud Function
        """
        return pulumi.get(self, "execution_timeout")

    @execution_timeout.setter
    def execution_timeout(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "execution_timeout", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        Folder ID for the Yandex Cloud Function
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter(name="imageSize")
    def image_size(self) -> Optional[pulumi.Input[int]]:
        """
        Image size for Yandex Cloud Function.
        """
        return pulumi.get(self, "image_size")

    @image_size.setter
    def image_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "image_size", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the Yandex Cloud Function
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter(name="loggroupId")
    def loggroup_id(self) -> Optional[pulumi.Input[str]]:
        """
        Loggroup ID size for Yandex Cloud Function.
        """
        return pulumi.get(self, "loggroup_id")

    @loggroup_id.setter
    def loggroup_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "loggroup_id", value)

    @property
    @pulumi.getter
    def memory(self) -> Optional[pulumi.Input[int]]:
        """
        Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        """
        return pulumi.get(self, "memory")

    @memory.setter
    def memory(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "memory", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Yandex Cloud Function name used to define trigger
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def package(self) -> Optional[pulumi.Input['FunctionPackageArgs']]:
        """
        Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
        * `package.0.sha_256` - SHA256 hash of the version deployment package.
        * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
        * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        """
        return pulumi.get(self, "package")

    @package.setter
    def package(self, value: Optional[pulumi.Input['FunctionPackageArgs']]):
        pulumi.set(self, "package", value)

    @property
    @pulumi.getter
    def runtime(self) -> Optional[pulumi.Input[str]]:
        """
        Runtime for Yandex Cloud Function
        """
        return pulumi.get(self, "runtime")

    @runtime.setter
    def runtime(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "runtime", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        Service account ID for Yandex Cloud Function
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="userHash")
    def user_hash(self) -> Optional[pulumi.Input[str]]:
        """
        User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        """
        return pulumi.get(self, "user_hash")

    @user_hash.setter
    def user_hash(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_hash", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        Version for Yandex Cloud Function.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)


class Function(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 content: Optional[pulumi.Input[pulumi.InputType['FunctionContentArgs']]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 entrypoint: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 execution_timeout: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 memory: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 package: Optional[pulumi.Input[pulumi.InputType['FunctionPackageArgs']]] = None,
                 runtime: Optional[pulumi.Input[str]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 user_hash: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Allows management of [Yandex Cloud Function](https://cloud.yandex.com/docs/functions/)

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        test_function = yandex.Function("test-function",
            content=yandex.FunctionContentArgs(
                zip_filename="function.zip",
            ),
            description="any description",
            entrypoint="main",
            execution_timeout="10",
            memory=128,
            runtime="python37",
            service_account_id="are1service2account3id",
            tags=["my_tag"],
            user_hash="any_user_defined_string")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['FunctionContentArgs']] content: Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `content.0.zip_filename` - Filename to zip archive for the version.
        :param pulumi.Input[str] description: Description of the Yandex Cloud Function
        :param pulumi.Input[str] entrypoint: Entrypoint for Yandex Cloud Function
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] environment: A set of key/value environment variables for Yandex Cloud Function
        :param pulumi.Input[str] execution_timeout: Execution timeout in seconds for Yandex Cloud Function
        :param pulumi.Input[str] folder_id: Folder ID for the Yandex Cloud Function
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Yandex Cloud Function
        :param pulumi.Input[int] memory: Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        :param pulumi.Input[str] name: Yandex Cloud Function name used to define trigger
        :param pulumi.Input[pulumi.InputType['FunctionPackageArgs']] package: Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `package.0.sha_256` - SHA256 hash of the version deployment package.
               * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
               * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        :param pulumi.Input[str] runtime: Runtime for Yandex Cloud Function
        :param pulumi.Input[str] service_account_id: Service account ID for Yandex Cloud Function
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        :param pulumi.Input[str] user_hash: User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FunctionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Allows management of [Yandex Cloud Function](https://cloud.yandex.com/docs/functions/)

        ## Example Usage

        ```python
        import pulumi
        import pulumi_yandex as yandex

        test_function = yandex.Function("test-function",
            content=yandex.FunctionContentArgs(
                zip_filename="function.zip",
            ),
            description="any description",
            entrypoint="main",
            execution_timeout="10",
            memory=128,
            runtime="python37",
            service_account_id="are1service2account3id",
            tags=["my_tag"],
            user_hash="any_user_defined_string")
        ```

        :param str resource_name: The name of the resource.
        :param FunctionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FunctionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 content: Optional[pulumi.Input[pulumi.InputType['FunctionContentArgs']]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 entrypoint: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 execution_timeout: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 memory: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 package: Optional[pulumi.Input[pulumi.InputType['FunctionPackageArgs']]] = None,
                 runtime: Optional[pulumi.Input[str]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 user_hash: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FunctionArgs.__new__(FunctionArgs)

            __props__.__dict__["content"] = content
            __props__.__dict__["description"] = description
            if entrypoint is None and not opts.urn:
                raise TypeError("Missing required property 'entrypoint'")
            __props__.__dict__["entrypoint"] = entrypoint
            __props__.__dict__["environment"] = environment
            __props__.__dict__["execution_timeout"] = execution_timeout
            __props__.__dict__["folder_id"] = folder_id
            __props__.__dict__["labels"] = labels
            if memory is None and not opts.urn:
                raise TypeError("Missing required property 'memory'")
            __props__.__dict__["memory"] = memory
            __props__.__dict__["name"] = name
            __props__.__dict__["package"] = package
            if runtime is None and not opts.urn:
                raise TypeError("Missing required property 'runtime'")
            __props__.__dict__["runtime"] = runtime
            __props__.__dict__["service_account_id"] = service_account_id
            __props__.__dict__["tags"] = tags
            if user_hash is None and not opts.urn:
                raise TypeError("Missing required property 'user_hash'")
            __props__.__dict__["user_hash"] = user_hash
            __props__.__dict__["created_at"] = None
            __props__.__dict__["image_size"] = None
            __props__.__dict__["loggroup_id"] = None
            __props__.__dict__["version"] = None
        super(Function, __self__).__init__(
            'yandex:index/function:Function',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            content: Optional[pulumi.Input[pulumi.InputType['FunctionContentArgs']]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            entrypoint: Optional[pulumi.Input[str]] = None,
            environment: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            execution_timeout: Optional[pulumi.Input[str]] = None,
            folder_id: Optional[pulumi.Input[str]] = None,
            image_size: Optional[pulumi.Input[int]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            loggroup_id: Optional[pulumi.Input[str]] = None,
            memory: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None,
            package: Optional[pulumi.Input[pulumi.InputType['FunctionPackageArgs']]] = None,
            runtime: Optional[pulumi.Input[str]] = None,
            service_account_id: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            user_hash: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[str]] = None) -> 'Function':
        """
        Get an existing Function resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['FunctionContentArgs']] content: Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `content.0.zip_filename` - Filename to zip archive for the version.
        :param pulumi.Input[str] created_at: Creation timestamp of the Yandex Cloud Function.
        :param pulumi.Input[str] description: Description of the Yandex Cloud Function
        :param pulumi.Input[str] entrypoint: Entrypoint for Yandex Cloud Function
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] environment: A set of key/value environment variables for Yandex Cloud Function
        :param pulumi.Input[str] execution_timeout: Execution timeout in seconds for Yandex Cloud Function
        :param pulumi.Input[str] folder_id: Folder ID for the Yandex Cloud Function
        :param pulumi.Input[int] image_size: Image size for Yandex Cloud Function.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the Yandex Cloud Function
        :param pulumi.Input[str] loggroup_id: Loggroup ID size for Yandex Cloud Function.
        :param pulumi.Input[int] memory: Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        :param pulumi.Input[str] name: Yandex Cloud Function name used to define trigger
        :param pulumi.Input[pulumi.InputType['FunctionPackageArgs']] package: Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
               * `package.0.sha_256` - SHA256 hash of the version deployment package.
               * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
               * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        :param pulumi.Input[str] runtime: Runtime for Yandex Cloud Function
        :param pulumi.Input[str] service_account_id: Service account ID for Yandex Cloud Function
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        :param pulumi.Input[str] user_hash: User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        :param pulumi.Input[str] version: Version for Yandex Cloud Function.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FunctionState.__new__(_FunctionState)

        __props__.__dict__["content"] = content
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["description"] = description
        __props__.__dict__["entrypoint"] = entrypoint
        __props__.__dict__["environment"] = environment
        __props__.__dict__["execution_timeout"] = execution_timeout
        __props__.__dict__["folder_id"] = folder_id
        __props__.__dict__["image_size"] = image_size
        __props__.__dict__["labels"] = labels
        __props__.__dict__["loggroup_id"] = loggroup_id
        __props__.__dict__["memory"] = memory
        __props__.__dict__["name"] = name
        __props__.__dict__["package"] = package
        __props__.__dict__["runtime"] = runtime
        __props__.__dict__["service_account_id"] = service_account_id
        __props__.__dict__["tags"] = tags
        __props__.__dict__["user_hash"] = user_hash
        __props__.__dict__["version"] = version
        return Function(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def content(self) -> pulumi.Output[Optional['outputs.FunctionContent']]:
        """
        Version deployment content for Yandex Cloud Function code. Can be only one `package` or `content` section.
        * `content.0.zip_filename` - Filename to zip archive for the version.
        """
        return pulumi.get(self, "content")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        Creation timestamp of the Yandex Cloud Function.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the Yandex Cloud Function
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def entrypoint(self) -> pulumi.Output[str]:
        """
        Entrypoint for Yandex Cloud Function
        """
        return pulumi.get(self, "entrypoint")

    @property
    @pulumi.getter
    def environment(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        A set of key/value environment variables for Yandex Cloud Function
        """
        return pulumi.get(self, "environment")

    @property
    @pulumi.getter(name="executionTimeout")
    def execution_timeout(self) -> pulumi.Output[Optional[str]]:
        """
        Execution timeout in seconds for Yandex Cloud Function
        """
        return pulumi.get(self, "execution_timeout")

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> pulumi.Output[str]:
        """
        Folder ID for the Yandex Cloud Function
        """
        return pulumi.get(self, "folder_id")

    @property
    @pulumi.getter(name="imageSize")
    def image_size(self) -> pulumi.Output[int]:
        """
        Image size for Yandex Cloud Function.
        """
        return pulumi.get(self, "image_size")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        A set of key/value label pairs to assign to the Yandex Cloud Function
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter(name="loggroupId")
    def loggroup_id(self) -> pulumi.Output[str]:
        """
        Loggroup ID size for Yandex Cloud Function.
        """
        return pulumi.get(self, "loggroup_id")

    @property
    @pulumi.getter
    def memory(self) -> pulumi.Output[int]:
        """
        Memory in megabytes (**aligned to 128MB**) for Yandex Cloud Function
        """
        return pulumi.get(self, "memory")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Yandex Cloud Function name used to define trigger
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def package(self) -> pulumi.Output[Optional['outputs.FunctionPackage']]:
        """
        Version deployment package for Yandex Cloud Function code. Can be only one `package` or `content` section.
        * `package.0.sha_256` - SHA256 hash of the version deployment package.
        * `package.0.bucket_name` - Name of the bucket that stores the code for the version.
        * `package.0.object_name` - Name of the object in the bucket that stores the code for the version.
        """
        return pulumi.get(self, "package")

    @property
    @pulumi.getter
    def runtime(self) -> pulumi.Output[str]:
        """
        Runtime for Yandex Cloud Function
        """
        return pulumi.get(self, "runtime")

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> pulumi.Output[Optional[str]]:
        """
        Service account ID for Yandex Cloud Function
        """
        return pulumi.get(self, "service_account_id")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Sequence[str]]:
        """
        Tags for Yandex Cloud Function. Tag "$latest" isn't returned.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="userHash")
    def user_hash(self) -> pulumi.Output[str]:
        """
        User-defined string for current function version. User must change this string any times when function changed. Function will be updated when hash is changed.
        """
        return pulumi.get(self, "user_hash")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[str]:
        """
        Version for Yandex Cloud Function.
        """
        return pulumi.get(self, "version")

