# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetAlbVirtualHostResult',
    'AwaitableGetAlbVirtualHostResult',
    'get_alb_virtual_host',
    'get_alb_virtual_host_output',
]

@pulumi.output_type
class GetAlbVirtualHostResult:
    """
    A collection of values returned by getAlbVirtualHost.
    """
    def __init__(__self__, authorities=None, http_router_id=None, id=None, modify_request_headers=None, modify_response_headers=None, name=None, routes=None, virtual_host_id=None):
        if authorities and not isinstance(authorities, list):
            raise TypeError("Expected argument 'authorities' to be a list")
        pulumi.set(__self__, "authorities", authorities)
        if http_router_id and not isinstance(http_router_id, str):
            raise TypeError("Expected argument 'http_router_id' to be a str")
        pulumi.set(__self__, "http_router_id", http_router_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if modify_request_headers and not isinstance(modify_request_headers, list):
            raise TypeError("Expected argument 'modify_request_headers' to be a list")
        pulumi.set(__self__, "modify_request_headers", modify_request_headers)
        if modify_response_headers and not isinstance(modify_response_headers, list):
            raise TypeError("Expected argument 'modify_response_headers' to be a list")
        pulumi.set(__self__, "modify_response_headers", modify_response_headers)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if routes and not isinstance(routes, list):
            raise TypeError("Expected argument 'routes' to be a list")
        pulumi.set(__self__, "routes", routes)
        if virtual_host_id and not isinstance(virtual_host_id, str):
            raise TypeError("Expected argument 'virtual_host_id' to be a str")
        pulumi.set(__self__, "virtual_host_id", virtual_host_id)

    @property
    @pulumi.getter
    def authorities(self) -> Sequence[str]:
        """
        A list of domains (host/authority header) that will be matched to this virtual host. Wildcard hosts are
        supported in the form of '*.foo.com' or '*-bar.foo.com'. If not specified, all domains will be matched.
        """
        return pulumi.get(self, "authorities")

    @property
    @pulumi.getter(name="httpRouterId")
    def http_router_id(self) -> str:
        return pulumi.get(self, "http_router_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="modifyRequestHeaders")
    def modify_request_headers(self) -> Sequence['outputs.GetAlbVirtualHostModifyRequestHeaderResult']:
        """
        Apply the following modifications to the request headers. The structure is documented
        below.
        """
        return pulumi.get(self, "modify_request_headers")

    @property
    @pulumi.getter(name="modifyResponseHeaders")
    def modify_response_headers(self) -> Sequence['outputs.GetAlbVirtualHostModifyResponseHeaderResult']:
        """
        Apply the following modifications to the response headers. The structure is documented
        below.
        """
        return pulumi.get(self, "modify_response_headers")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        name of the route.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def routes(self) -> Sequence['outputs.GetAlbVirtualHostRouteResult']:
        """
        A Route resource. Routes are matched *in-order*. Be careful when adding them to the end. For instance,
        having http '/' match first makes all other routes unused. The structure is documented below.
        """
        return pulumi.get(self, "routes")

    @property
    @pulumi.getter(name="virtualHostId")
    def virtual_host_id(self) -> str:
        return pulumi.get(self, "virtual_host_id")


class AwaitableGetAlbVirtualHostResult(GetAlbVirtualHostResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAlbVirtualHostResult(
            authorities=self.authorities,
            http_router_id=self.http_router_id,
            id=self.id,
            modify_request_headers=self.modify_request_headers,
            modify_response_headers=self.modify_response_headers,
            name=self.name,
            routes=self.routes,
            virtual_host_id=self.virtual_host_id)


def get_alb_virtual_host(http_router_id: Optional[str] = None,
                         name: Optional[str] = None,
                         virtual_host_id: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAlbVirtualHostResult:
    """
    Get information about a Yandex ALB Virtual Host. For more information, see
    [Yandex.Cloud Application Load Balancer](https://cloud.yandex.com/en/docs/application-load-balancer/quickstart).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_yandex as yandex

    my_vh_data = yandex.get_alb_virtual_host(name=yandex_alb_virtual_host["my-vh"]["name"],
        http_router_id=yandex_alb_virtual_host["my-router"]["id"])
    ```

    This data source is used to define [Application Load Balancer Virtual Host] that can be used by other resources.


    :param str http_router_id: HTTP Router that the resource belongs to.
    :param str name: Name of the Virtual Host.
    :param str virtual_host_id: The ID of a specific Virtual Host. Virtual Host ID is concatenation of HTTP Router ID
           and Virtual Host name with `/` symbol between them. For Example, "http_router_id/vhost_name".
    """
    __args__ = dict()
    __args__['httpRouterId'] = http_router_id
    __args__['name'] = name
    __args__['virtualHostId'] = virtual_host_id
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('yandex:index/getAlbVirtualHost:getAlbVirtualHost', __args__, opts=opts, typ=GetAlbVirtualHostResult).value

    return AwaitableGetAlbVirtualHostResult(
        authorities=__ret__.authorities,
        http_router_id=__ret__.http_router_id,
        id=__ret__.id,
        modify_request_headers=__ret__.modify_request_headers,
        modify_response_headers=__ret__.modify_response_headers,
        name=__ret__.name,
        routes=__ret__.routes,
        virtual_host_id=__ret__.virtual_host_id)


@_utilities.lift_output_func(get_alb_virtual_host)
def get_alb_virtual_host_output(http_router_id: Optional[pulumi.Input[Optional[str]]] = None,
                                name: Optional[pulumi.Input[Optional[str]]] = None,
                                virtual_host_id: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAlbVirtualHostResult]:
    """
    Get information about a Yandex ALB Virtual Host. For more information, see
    [Yandex.Cloud Application Load Balancer](https://cloud.yandex.com/en/docs/application-load-balancer/quickstart).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_yandex as yandex

    my_vh_data = yandex.get_alb_virtual_host(name=yandex_alb_virtual_host["my-vh"]["name"],
        http_router_id=yandex_alb_virtual_host["my-router"]["id"])
    ```

    This data source is used to define [Application Load Balancer Virtual Host] that can be used by other resources.


    :param str http_router_id: HTTP Router that the resource belongs to.
    :param str name: Name of the Virtual Host.
    :param str virtual_host_id: The ID of a specific Virtual Host. Virtual Host ID is concatenation of HTTP Router ID
           and Virtual Host name with `/` symbol between them. For Example, "http_router_id/vhost_name".
    """
    ...
